


#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
    variable LogFlag

   if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

}

if {$started == 0} {
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable AddrSpaceList
    variable OffsetList

    variable AddrSpace
    variable Address
    variable Offset
    variable SData
    variable GData

    set AddrSpaceList [list \
          "Control: 0x000" \
          "ASIC Readout Control: 0x300" \
          "Timestamp Control: 0x400" \
          "Discriminator Control: 0x500" \
          "ASIC Data: 0x2000" \
          "Discriminator Data: 0x3000" \
          "ASIC Controls: 0x4000"  \
    ]

    set OffsetList [list 0 1 2 3 4 5 6 7 8 9]

    set Address 0x0000
    set AddrSpace [lindex $AddrSpaceList 0]
    set Offset 0
    set SData            0x0000
    set GData            ******

   proc  show_variables {} {
        variable AddrSpace
        variable Address
        variable Offset
        variable SData
        variable GData

        InsertLog "AddrSpace=$AddrSpace; Address=$Address; Offset=$Offset; SetData=$SData; GetData=$GData"
   }

    proc do_get {Addr}  {
        global errorCode errorInfo

        set rc [catch {interp eval "" ::namespace inscope ::urn:XAIDAAccessServer do_Get $Addr} m]
        if {$rc != 0} {
            InsertLog "Get returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#  InsertLog "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }

    proc do_set {Addr Vl}  {
        global errorCode errorInfo

        set rc [catch {interp eval "" ::namespace inscope ::urn:XAIDAAccessServer do_Set $Addr $Vl} m]
        if {$rc != 0} {
            InsertLog "Get returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#  InsertLog "Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }

   proc do_setget {Addr Vl} {
      do_set $Addr $Vl
      set rc [do_get $Addr]
      return $rc
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogText
       variable ShowLogFlag
       variable LogFlag
       variable Address
       variable AddrSpace
       variable Offset
       variable SData
       variable GData

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
          InsertLog "CGI data is too short: $cgDiagnostics.tmlidata"
       } else {
          if {[lindex $cgidata 0] != "Widget"} then {
             InsertLog "Invalid CGI data: $cgidata"
          } else {

            switch -glob [first [lindex $cgidata 1]] {

                RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                SET      {do_set [expr $Address + $Offset] $SData}
                GET      {set GData [do_get [expr $Address + $Offset]]}
                SETGET   {set GData [do_setget [expr $Address + $Offset] $SData]}
                VERSION  {InsertLog "Firmware Version = [do_get 3]"}

                ADDRSPACE  {set Address [last [lindex $cgidata 1]]; set AddrSpace "[lreplace [lindex $cgidata 1] 0 0]"}
                OFFSET     {set Offset  [last [lindex $cgidata 1]]}
                SDATA      {set SData [last $cgidata 1]]}

                MainLog {}
                undefined {}
                default {InsertLog "unexpected CGI data:  $cgidata"}
            }
         }
      }
   }

}   ;# end of if {$started == 0} 

